"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AddDeploymentProperties1646865380689 = void 0;
class AddDeploymentProperties1646865380689 {
    constructor() {
        this.name = 'AddDeploymentProperties1646865380689';
    }
    async up(queryRunner) {
        await queryRunner.query(`CREATE TABLE "certificate_deployment_properties" ("registry" character varying NOT NULL, "issuer" character varying NOT NULL, CONSTRAINT "PK_0b3f711854067e456735f0d25eb" PRIMARY KEY ("registry"))`);
        await this.migrateBlockchainProperties(queryRunner);
    }
    async down(queryRunner) {
        await queryRunner.query(`DROP TABLE "certificate_deployment_properties"`);
    }
    async migrateBlockchainProperties(queryRunner) {
        const tableExists = await this.blockchainPropertiesExist(queryRunner);
        if (tableExists) {
            const props = await queryRunner.query(`SELECT registry, issuer from issuer_blockchain_properties;`);
            if (props.length) {
                await this.addExistingProperties(queryRunner, props[0].registry, props[0].issuer);
            }
        }
    }
    async addExistingProperties(queryRunner, registry, issuer) {
        await queryRunner.query(`INSERT INTO certificate_deployment_properties VALUES ('${registry}', '${issuer}');`);
    }
    async blockchainPropertiesExist(queryRunner) {
        const exists = await queryRunner.query(`SELECT EXISTS (
            SELECT FROM 
                pg_tables
            WHERE 
                schemaname = 'public' AND 
                tablename  = 'issuer_blockchain_properties'
            );`);
        return exists[0].exists;
    }
}
exports.AddDeploymentProperties1646865380689 = AddDeploymentProperties1646865380689;
//# sourceMappingURL=1646865380689-AddDeploymentProperties.js.map