export declare namespace CertificateErrors {
    namespace Issuance {
        class CertificateAlreadyIssued extends Error {
            constructor(internalCertificateId: number);
        }
    }
    namespace Transfer {
        class FromZeroAddress extends Error {
            constructor(internalCertificateId: number);
        }
        class ToZeroAddress extends Error {
            constructor(internalCertificateId: number);
        }
        class NotEnoughBalance extends Error {
            constructor(internalCertificateId: any, address: any);
        }
    }
    namespace Claim {
        class ForZeroAddress extends Error {
            constructor(internalCertificateId: number);
        }
        class NotEnoughBalance extends Error {
            constructor(internalCertificateId: any, address: any);
        }
    }
    class BatchError extends Error {
        constructor(originError: Error);
    }
    class UnknownEventType extends Error {
        constructor(internalCertificateId: number, eventType: string);
    }
    class FirstCertificateEventIsNotIssuance extends Error {
        constructor(internalCertificateId: number, type: string);
    }
    class CertificateNoEvents extends Error {
        constructor();
    }
    class CertificateTooManyPersisted extends Error {
        constructor(internalCertificateId: number, toPersistCounter: number);
    }
}
