import { CertificateEventEntity } from './CertificateEvent.entity';
import { CertificateEventRepository, UnsavedEvent } from './CertificateEvent.repository';
import { CertificateSynchronizationAttemptEntity } from './CertificateSynchronizationAttempt.entity';
export declare class CertificateEventInMemoryRepository implements CertificateEventRepository {
    private internalCertificateIdSerial;
    private eventDb;
    private attemptDb;
    private maxSynchronizationAttemptsForEvent;
    getAll(): Promise<CertificateEventEntity[]>;
    getByInternalCertificateId(internalCertId: number): Promise<CertificateEventEntity[]>;
    save(event: UnsavedEvent, commandId: number): Promise<CertificateEventEntity>;
    saveMany(events: (UnsavedEvent & {
        commandId: number;
    })[]): Promise<CertificateEventEntity[]>;
    createSynchronizationAttempt(eventId: number): Promise<CertificateSynchronizationAttemptEntity>;
    createSynchronizationAttempts(eventIds: number[]): Promise<CertificateSynchronizationAttemptEntity[]>;
    updateAttempt({ eventIds, error }: {
        eventIds: any;
        error: any;
    }): Promise<CertificateSynchronizationAttemptEntity[]>;
    findAllToProcess(): Promise<CertificateEventEntity[]>;
    getOne(eventId: number): Promise<CertificateEventEntity>;
    getBlockchainIdMap(internalCertIds: number[]): Promise<Record<number, number>>;
    getNextInternalCertificateId(): Promise<number>;
}
