import { EntityManager, Repository } from 'typeorm';
import { CertificateEventEntity } from './CertificateEvent.entity';
import { CertificateEventRepository, IGetToProcessOptions } from './CertificateEvent.repository';
import { ICertificateEvent } from '../../events/Certificate.events';
import { CertificateSynchronizationAttemptEntity } from './CertificateSynchronizationAttempt.entity';
import { ConfigService } from '@nestjs/config';
import { Configuration } from '../../config/config.interface';
export declare class CertificateEventPostgresRepository implements CertificateEventRepository {
    private repository;
    private synchronizationAttemptRepository;
    private readonly maxSynchronizationAttemptsForEvent;
    constructor(repository: Repository<CertificateEventEntity>, synchronizationAttemptRepository: Repository<CertificateSynchronizationAttemptEntity>, configService: ConfigService<Configuration>);
    getAll(): Promise<CertificateEventEntity[]>;
    getByInternalCertificateId(internalCertId: number): Promise<CertificateEventEntity[]>;
    save(event: Omit<ICertificateEvent, 'id'>, commandId: number, txManager: EntityManager | null): Promise<CertificateEventEntity>;
    saveMany(events: (Omit<ICertificateEvent, 'id'> & {
        commandId: number;
    })[], txManager: EntityManager | null): Promise<CertificateEventEntity[]>;
    createSynchronizationAttempt(eventId: number, txManager: EntityManager | null): Promise<CertificateSynchronizationAttemptEntity>;
    createSynchronizationAttempts(eventIds: number[], txManager: EntityManager | null): Promise<CertificateSynchronizationAttemptEntity[]>;
    updateAttempt({ eventIds, error }: {
        eventIds: any;
        error: any;
    }): Promise<CertificateSynchronizationAttemptEntity[]>;
    findAllToProcess(params: IGetToProcessOptions): Promise<CertificateEventEntity[]>;
    getOne(eventId: number): Promise<CertificateEventEntity>;
    getBlockchainIdMap(internalCertIds: number[]): Promise<Record<number, number>>;
    getNextInternalCertificateId(): Promise<number>;
}
