import { OnChainCertificateService } from '../../../onchain-certificate/onchain-certificate.service';
import { CertificateIssuedEvent } from '../../events/Certificate.events';
import { OffChainCertificateService } from '../../offchain-certificate.service';
import { BatchConfigurationService } from '../strategies/batch/batch.configuration';
export declare class IssuePersistHandler {
    private readonly certificateService;
    private readonly offchainCertificateService;
    private batchConfigurationService;
    constructor(certificateService: OnChainCertificateService<unknown>, offchainCertificateService: OffChainCertificateService, batchConfigurationService: BatchConfigurationService);
    private synchronizeBatchBlock;
    handleBatch(events: CertificateIssuedEvent[]): Promise<{
        failedCertificateIds: number[];
    }>;
}
