"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BatchConfigurationServiceForUnitTests = exports.BatchConfigurationService = exports.BATCH_CONFIGURATION_TOKEN = void 0;
const config_1 = require("@nestjs/config");
const common_1 = require("@nestjs/common");
exports.BATCH_CONFIGURATION_TOKEN = Symbol.for('BATCH_CONFIGURATION_TOKEN');
let BatchConfigurationService = class BatchConfigurationService {
    constructor(configService) {
        this.configService = configService;
    }
    getBatchSizes() {
        const issueSize = this.configService.get('ISSUE_BATCH_SIZE');
        const claimSize = this.configService.get('CLAIM_BATCH_SIZE');
        const transferSize = this.configService.get('TRANSFER_BATCH_SIZE');
        return {
            issueBatchSize: issueSize ? parseInt(issueSize) : 10,
            claimBatchSize: claimSize ? parseInt(claimSize) : 20,
            transferBatchSize: transferSize ? parseInt(transferSize) : 20
        };
    }
};
BatchConfigurationService = __decorate([
    common_1.Injectable(),
    __metadata("design:paramtypes", [config_1.ConfigService])
], BatchConfigurationService);
exports.BatchConfigurationService = BatchConfigurationService;
let BatchConfigurationServiceForUnitTests = class BatchConfigurationServiceForUnitTests {
    getBatchSizes() {
        return {
            issueBatchSize: 10,
            claimBatchSize: 20,
            transferBatchSize: 20
        };
    }
};
BatchConfigurationServiceForUnitTests = __decorate([
    common_1.Injectable()
], BatchConfigurationServiceForUnitTests);
exports.BatchConfigurationServiceForUnitTests = BatchConfigurationServiceForUnitTests;
//# sourceMappingURL=batch.configuration.js.map