"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.zipEventsWithCommandId = exports.isTransferCommand = exports.createIssueEventsFromCommands = exports.createEventFromCommand = exports.createAggregatesFromCertificateGroups = exports.groupByInternalCertificateId = void 0;
const Certificate_events_1 = require("../events/Certificate.events");
const lodash_1 = require("lodash");
const groupByInternalCertificateId = (entityWithCertificateId) => lodash_1.groupBy(entityWithCertificateId, 'internalCertificateId');
exports.groupByInternalCertificateId = groupByInternalCertificateId;
const createAggregatesFromCertificateGroups = async (certificateEventsGroups, createAggregateFunction) => await Promise.all(Object.values(certificateEventsGroups).map(async (eventsForCertificate) => await createAggregateFunction(eventsForCertificate)));
exports.createAggregatesFromCertificateGroups = createAggregatesFromCertificateGroups;
const createEventFromCommand = (command) => {
    if (exports.isTransferCommand(command)) {
        return Certificate_events_1.CertificateTransferredEvent.createNew(command.certificateId, command);
    }
    return Certificate_events_1.CertificateClaimedEvent.createNew(command.certificateId, command);
};
exports.createEventFromCommand = createEventFromCommand;
const createIssueEventsFromCommands = async (commands, getIdFunction) => await Promise.all(commands.map(async (command) => Certificate_events_1.CertificateIssuedEvent.createNew(await getIdFunction(), command)));
exports.createIssueEventsFromCommands = createIssueEventsFromCommands;
const isTransferCommand = (command) => {
    return command.fromAddress && command.toAddress;
};
exports.isTransferCommand = isTransferCommand;
const zipEventsWithCommandId = (events, commands) => events.map((event, index) => ({ ...event, commandId: commands[index].id }));
exports.zipEventsWithCommandId = zipEventsWithCommandId;
//# sourceMappingURL=batch.utils.js.map