"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.IsEnergyValue = exports.IsEnergyValueConstraint = void 0;
const class_validator_1 = require("class-validator");
const ethers_1 = require("ethers");
let IsEnergyValueConstraint = class IsEnergyValueConstraint {
    validate(value) {
        try {
            const isNegative = ethers_1.BigNumber.from(value).isNegative();
            return !isNegative;
        }
        catch (e) {
            return false;
        }
    }
    defaultMessage(args) {
        return `"${args.value}" is not valid energy volume`;
    }
};
IsEnergyValueConstraint = __decorate([
    class_validator_1.ValidatorConstraint({ name: 'isEnergyValue' })
], IsEnergyValueConstraint);
exports.IsEnergyValueConstraint = IsEnergyValueConstraint;
function IsEnergyValue(validationOptions) {
    return (object, propertyName) => {
        class_validator_1.registerDecorator({
            name: 'isEnergyValue',
            target: object.constructor,
            propertyName,
            constraints: [propertyName],
            options: validationOptions,
            validator: IsEnergyValueConstraint
        });
    };
}
exports.IsEnergyValue = IsEnergyValue;
//# sourceMappingURL=is-energy-value.js.map