import { IBlockchainProperties } from '@energyweb/issuer';
import { ConfigService } from '@nestjs/config';
import { DeploymentPropertiesRepository } from './repositories/deploymentProperties/deploymentProperties.repository';
import { providers, Signer } from 'ethers';
export interface BlockchainProperties {
    rpcNode: string;
    fallbackRpcNode: string | null;
    registry: string;
    issuer: string;
}
export declare class BlockchainPropertiesService {
    private configService;
    private deploymentPropsRepo;
    private readonly fallbackRPC;
    private readonly primaryRPC;
    private readonly issuerPrivateKey;
    constructor(configService: ConfigService<{
        WEB3: string;
        ISSUER_PRIVATE_KEY: string;
    }>, deploymentPropsRepo: DeploymentPropertiesRepository);
    get(): Promise<BlockchainProperties>;
    getWrapped(): Promise<IBlockchainProperties>;
    deploy(): Promise<void>;
    isDeployed(): Promise<boolean>;
    wrap(privateKey: string): Promise<{
        web3: providers.FallbackProvider | providers.JsonRpcProvider;
        registry: import("@energyweb/issuer/dist/js/src/ethers/RegistryExtended").RegistryExtended;
        issuer: import("@energyweb/issuer/dist/js/src/ethers/Issuer").Issuer;
        activeUser: Signer;
    }>;
    private assure0x;
}
