import { OnModuleInit } from '@nestjs/common';
import { providers } from 'ethers';
import { IBlockchainProperties } from '@energyweb/issuer';
import { ConfigService } from '@nestjs/config';
import { BlockchainPropertiesService } from '../blockchain-properties.service';
import { TransactionPollService } from '../certificate-operations/transaction-poll.service';
export declare class OnChainWatcher implements OnModuleInit {
    private readonly configService;
    private readonly blockchainPropertiesService;
    private readonly transactionPollService;
    private readonly logger;
    provider: providers.FallbackProvider | providers.JsonRpcProvider;
    registry: IBlockchainProperties['registry'];
    constructor(configService: ConfigService, blockchainPropertiesService: BlockchainPropertiesService, transactionPollService: TransactionPollService);
    onModuleInit(): Promise<void>;
    processEvent(eventType: BlockchainEventType, rawEvent: providers.Log): Promise<void>;
    private logEvent;
    onApplicationShutdown(): Promise<void>;
}
export declare enum BlockchainEventType {
    IssuanceSingle = "IssuanceSingle",
    IssuanceBatch = "IssuanceBatch",
    TransferSingle = "TransferSingle",
    TransferBatch = "TransferBatch",
    ClaimSingle = "ClaimSingle",
    ClaimBatch = "ClaimBatch",
    TransferBatchMultiple = "TransferBatchMultiple",
    ClaimBatchMultiple = "ClaimBatchMultiple"
}
