"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.OnChainCertificateForUnitTestsModule = exports.OnChainCertificateModule = void 0;
const common_1 = require("@nestjs/common");
const cqrs_1 = require("@nestjs/cqrs");
const bull_1 = require("@nestjs/bull");
const transaction_poll_service_1 = require("./certificate-operations/transaction-poll.service");
const onchain_certificateForUnitTests_service_1 = require("./onchain-certificateForUnitTests.service");
const onchain_certificate_service_1 = require("./onchain-certificate.service");
const blockchain_actions_processor_1 = require("./blockchain-actions.processor");
const types_1 = require("./types");
const configuration_1 = __importDefault(require("../offchain-certificate/config/configuration"));
const config_1 = require("@nestjs/config");
const blockchain_properties_service_1 = require("./blockchain-properties.service");
const onChainCertificateFacade_1 = require("./onChainCertificateFacade");
const deploymentProperties_repository_1 = require("./repositories/deploymentProperties/deploymentProperties.repository");
const deploymentPropertiesPostgres_repository_1 = require("./repositories/deploymentProperties/deploymentPropertiesPostgres.repository");
const typeorm_1 = require("@nestjs/typeorm");
const deploymentProperties_entity_1 = require("./repositories/deploymentProperties/deploymentProperties.entity");
const batch_claim_certificates_handler_1 = require("./certificate-operations/claim/batch-claim-certificates.handler");
const batch_issue_certificates_handler_1 = require("./certificate-operations/issue/batch-issue-certificates.handler");
const batch_transfer_certificates_handler_1 = require("./certificate-operations/transfer/batch-transfer-certificates.handler");
const claim_certificate_handler_1 = require("./certificate-operations/claim/claim-certificate.handler");
const issue_certificate_handler_1 = require("./certificate-operations/issue/issue-certificate.handler");
const transfer_certificate_handler_1 = require("./certificate-operations/transfer/transfer-certificate.handler");
const certificate_operations_service_1 = require("./certificate-operations/certificate-operations.service");
const repository_keys_1 = require("../offchain-certificate/repositories/repository.keys");
const CertificateReadModelInMemory_repository_1 = require("../offchain-certificate/repositories/CertificateReadModel/CertificateReadModelInMemory.repository");
const CertificateReadModelPostgres_repository_1 = require("../offchain-certificate/repositories/CertificateReadModel/CertificateReadModelPostgres.repository");
const CertificateReadModel_entity_1 = require("../offchain-certificate/repositories/CertificateReadModel/CertificateReadModel.entity");
const on_chain_certificates_listener_1 = require("./listeners/on-chain-certificates.listener");
const realCertificateProvider = {
    provide: types_1.ONCHAIN_CERTIFICATE_SERVICE_TOKEN,
    useClass: onchain_certificate_service_1.OnChainCertificateService
};
let OnChainCertificateModule = class OnChainCertificateModule {
};
OnChainCertificateModule = __decorate([
    common_1.Module({
        providers: [
            realCertificateProvider,
            blockchain_actions_processor_1.BlockchainActionsProcessor,
            transaction_poll_service_1.TransactionPollService,
            blockchain_properties_service_1.BlockchainPropertiesService,
            onChainCertificateFacade_1.OnChainCertificateFacade,
            batch_claim_certificates_handler_1.BatchClaimCertificatesHandler,
            batch_issue_certificates_handler_1.BatchIssueCertificatesHandler,
            batch_transfer_certificates_handler_1.BatchTransferCertificatesHandler,
            claim_certificate_handler_1.ClaimCertificateHandler,
            issue_certificate_handler_1.IssueCertificateHandler,
            transfer_certificate_handler_1.TransferCertificateHandler,
            certificate_operations_service_1.CertificateOperationsService,
            transaction_poll_service_1.TransactionPollService,
            on_chain_certificates_listener_1.OnChainWatcher,
            {
                provide: deploymentProperties_repository_1.DeploymentPropertiesRepository,
                useClass: deploymentPropertiesPostgres_repository_1.DeploymentPropertiesPostgresRepository
            },
            {
                provide: repository_keys_1.CERTIFICATE_READ_MODEL_REPOSITORY,
                useClass: CertificateReadModelPostgres_repository_1.CertificateReadModelPostgresRepository
            }
        ],
        exports: [realCertificateProvider, onChainCertificateFacade_1.OnChainCertificateFacade],
        imports: [
            config_1.ConfigModule.forRoot({
                isGlobal: true,
                load: [configuration_1.default]
            }),
            cqrs_1.CqrsModule,
            bull_1.BullModule.registerQueueAsync({
                name: blockchain_actions_processor_1.blockchainQueueName,
                inject: [config_1.ConfigService],
                useFactory: (configService) => ({
                    settings: {
                        lockDuration: configService.get('CERTIFICATE_QUEUE_LOCK_DURATION')
                    }
                })
            }),
            typeorm_1.TypeOrmModule.forFeature([deploymentProperties_entity_1.DeploymentPropertiesEntity, CertificateReadModel_entity_1.CertificateReadModelEntity])
        ]
    })
], OnChainCertificateModule);
exports.OnChainCertificateModule = OnChainCertificateModule;
const inMemoryServiceProvider = {
    provide: types_1.ONCHAIN_CERTIFICATE_SERVICE_TOKEN,
    useClass: onchain_certificateForUnitTests_service_1.CertificateForUnitTestsService
};
let OnChainCertificateForUnitTestsModule = class OnChainCertificateForUnitTestsModule {
};
OnChainCertificateForUnitTestsModule = __decorate([
    common_1.Module({
        providers: [
            inMemoryServiceProvider,
            {
                provide: repository_keys_1.CERTIFICATE_READ_MODEL_REPOSITORY,
                useClass: CertificateReadModelInMemory_repository_1.CertificateReadModelInMemoryRepository
            }
        ],
        exports: [inMemoryServiceProvider],
        imports: [cqrs_1.CqrsModule]
    })
], OnChainCertificateForUnitTestsModule);
exports.OnChainCertificateForUnitTestsModule = OnChainCertificateForUnitTestsModule;
//# sourceMappingURL=onchain-certificate.module.js.map